/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','./library','sap/ui/core/Control'],function(q,l,C){"use strict";var T=C.extend("sap.ui.commons.TriStateCheckBox",{metadata:{library:"sap.ui.commons",properties:{selectionState:{type:"sap.ui.commons.TriStateCheckBoxState",group:"Data",defaultValue:sap.ui.commons.TriStateCheckBoxState.Unchecked},text:{type:"string",group:"Appearance",defaultValue:null},enabled:{type:"boolean",group:"Behavior",defaultValue:true},editable:{type:"boolean",group:"Behavior",defaultValue:true},valueState:{type:"sap.ui.core.ValueState",group:"Data",defaultValue:sap.ui.core.ValueState.None},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:sap.ui.core.TextDirection.Inherit}},events:{change:{parameters:{selectionState:{type:"string"}}}}}});T.prototype.onclick=function(e){if(!!sap.ui.Device.browser.internet_explorer&&(!this.getEnabled())){this.$().attr("tabindex",0).addClass("sapUiTriCbFoc");}this.userToggle(e);};T.prototype.onfocusout=function(e){if(!!sap.ui.Device.browser.internet_explorer&&(!this.getEnabled())){this.$().attr("tabindex",-1).removeClass("sapUiTriCbFoc");}};T.prototype.onsapspace=function(e){e.preventDefault();this.userToggle(e);};T.prototype.userToggle=function(e){if(this.getEnabled()&&this.getEditable()){if(this.getSelectionState()==='Mixed'||this.getSelectionState()==="Unchecked"){this.toggle("Checked");}else{this.toggle("Unchecked");}this.fireChange({selectionState:this.getSelectionState()});}else{this.getDomRef().focus();}};T.prototype.toggle=function(d){if(d in sap.ui.commons.TriStateCheckBoxState){this.setSelectionState(d);}};return T;},true);
